#include "testlib.h"
#include <stdio.h>

using namespace std;

const int NMAX = 100000 + 5;
const int AMAX = 1000000000;

int p, q;
long long s[NMAX];
long long partSum[NMAX];

long long sum(int l, int r) {
    l = (l-1) % p + 1;
    r = (r-1) % p + 1;
    if (l > r) {
        return sum(l, p) + sum(1, r);
    }
    return partSum[r] - partSum[l-1];
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    p = inf.readInt();
    q = inf.readInt();
    for (int i=1;i<=p;i++) {
        s[i] = inf.readLong();
    }
    
    partSum[0] = 0;
    for (int i=1;i<=p;i++) {
        long long nxt = ouf.readLong();
        if (nxt < 1 || nxt > AMAX) {
            quitf(_wa, "Invalid number %lld at index %d", nxt, i);
        }
        int nw = (int)nxt;
        partSum[i] = partSum[i-1] + nw;
    }
    
    for (int i=1;i<=p;i++) {
        long long realSum = sum(i,q+i-1);
        if (realSum != s[i]) {
            quitf(_wa, "Invalid sum with index %d, expected %lld, but %lld found", i, s[i], realSum);
        }
    }
    
    quitf(_ok, "Contestant found the answer");
    
    return 0;
}
