#include <stdio.h>
#include <cstdlib>

using namespace std;

const int OK = 0;
const int FAIL = 3;
const int PE = 4;
const int WA = 5;

FILE *fi, *fo, *fa, *fr;
bool report;

void quit(int exitCode, char *message)
{
    if (report)
    {
        fprintf(fr, "%s\n", message);
        fclose(fr);
    }
    else
        printf("%s\n", message);
    fclose(fi);
    fclose(fo);
    fclose(fa);
    exit(exitCode);
}

int main(int argc, char *argv[])
{
    if (argc < 4)
    {
        printf("usage: checker.exe INPUT-FILE CONTESTANT-OUTPUT-FILE AUTHOR-OUTPUT-FILE [REPORT-FILE]\n");
        return 1;
    }
    fi = fopen(argv[1], "r");
    fo = fopen(argv[2], "r");
    fa = fopen(argv[3], "r");
    if (argc >= 5)
    {
        fr = fopen(argv[4], "a");
        report = true;
    } else
        report = false;

    char* options[1] = {"dlulurrrdddllluluuurrrr"};
    char in[23];
    for (int i = 0; i < 23; i++)
    {
        if (fscanf(fo, "%c", &in[i]) < 1)
            quit(WA, "Wrong answer");
        if (in[i] != 'u' && in[i] != 'd' && in[i] != 'l' && in[i] != 'r')
            quit(WA, "Wrong answer");
    }

    char c;
    if (fscanf(fo, "%c", &c) == 1 && c != '\n' && c != '\r')
        quit(WA, "Wrong answer");

    for (int option = 0; option < 1; option++)
    {
        bool willDo = true;
        for (int i = 0; i < 23; i++)
            if (in[i] != options[option][i])
            {
                willDo = false;
                break;
            }
        if (willDo)
            quit(OK, "OK");
    }

    quit(WA, "Wrong answer");
}
