#include "testlib.h"
#include <stdio.h>

using namespace std;

const int NMAX = 100000;
const int XMIN = -1000000000;
const int XMAX = 1000000000;

int n;
int separators[NMAX];
int nextLayer[NMAX];
int nextLayerCount = 0;
int separatorsCount = 0;
bool used[NMAX+1];

int readAns(InStream& in) {
    int ans = in.readInt();
    for (int i=1;i<=n;i++) {
        used[i] = false;
    }
    for (int i=0;i<ans;i++) {
        int k = in.readInt(1, NMAX, "k_i");
        nextLayerCount = k;
        nextLayer[0] = 0;
        for (int j=0;j<k;j++) {
            int nxt = in.readInt(1, n, "a_i_j");
            if (used[nxt]) {
                in.quitf(_wa, "Rectangle 1*%d was used more than once", nxt);
            }
            if (nextLayer[j]*1ll + nxt > XMAX) {
                in.quitf(_wa, "Layer %d right side coordinate is too big", i+1);
            }
            used[nxt] = true;
            nextLayer[j+1] = nextLayer[j] + nxt;
        }
        
        if (i > 0) {
            if (nextLayer[nextLayerCount] > separators[separatorsCount - 1] || nextLayer[0] < separators[0]) {
                in.quitf(_wa, "Layer %d does not lay completely on lower layer", i+1);
            }
            
            int currentSeparator = 0;
            int currentNext = 0;
            while (currentNext < nextLayerCount && currentSeparator < separatorsCount) {
                while (currentSeparator < separatorsCount && separators[currentSeparator] <= nextLayer[currentNext]) currentSeparator++;
                bool failed = false;
                if (currentSeparator == separatorsCount) {
                    failed = true;
                } else if (separators[currentSeparator] >= nextLayer[currentNext + 1]) {
                    failed = true;
                }
                
                if (failed) {
                    in.quitf(_wa, "Rectangle 1*%d in layer %d lay on only one rectangle.", nextLayer[currentNext + 1] - nextLayer[currentNext], i+1);
                } else {
                    currentNext++;
                }
            }
        }
        
        separatorsCount = nextLayerCount + 1;
        swap(separators, nextLayer);
    }
    
    return ans;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    int pa = readAns(ouf);
    int ja = readAns(ans);
    if (pa == ja)
        quitf(_ok, "Contestant found the answer");
    else if (pa > ja)
        quitf(_fail, "PANIC! Contestant found better answer than jury!");
    else
        quitf(_wa, "Contestant's solution isn't the best one");
    return 0;
}