#include "testlib.h"

using namespace std;

const int max_n = 101111;

struct tree {
    long long sum[4 * max_n], f[4 * max_n];
    tree() {
        memset(f, 0, sizeof(f));
        memset(sum, 0, sizeof(sum));
    }
    void build(int v, int l, int r, int a[]) {
        f[v] = 0;
        if (l == r) {
            sum[v] = a[l];
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v, l, mid, a);
        build(2 * v + 1, mid + 1, r, a);
        sum[v] = sum[2 * v] + sum[2 * v + 1];
    }
    void push(int v, int l, int r, int mid) {
        if (f[v]) {
            sum[2 * v] += 1LL * f[v] * (mid - l + 1);
            sum[2 * v + 1] += 1LL * f[v] * (r - mid);
            f[2 * v] += f[v];
            f[2 * v + 1] += f[v];
            f[v] = 0;
        }
    }
    void update(int v, int tl, int tr, int l, int r, int x) {
        if (tl == l && tr == r) {
            sum[v] += 1LL * (r - l + 1) * x;
            f[v] += x;
            return;
        }
        int mid = (tl + tr) / 2;
        push(v, tl, tr, mid);
        if (r <= mid) {
            update(2 * v, tl, mid, l, r, x);
        } else if (l > mid) {
            update(2 * v + 1, mid + 1, tr, l, r, x);
        } else {
            update(2 * v, tl, mid, l, mid, x);
            update(2 * v + 1, mid + 1, tr, mid + 1, r, x);
        }
        sum[v] = sum[2 * v] + sum[2 * v + 1];
    }
    long long get_sum(int v, int tl, int tr, int l, int r) {
        if (tl == l && tr == r) {
            return sum[v];
        }
        int mid = (tl + tr) / 2;
        push(v, tl, tr, mid);
        if (r <= mid) {
            return get_sum(2 * v, tl, mid, l, r);
        } else if (l > mid) {
            return get_sum(2 * v + 1, mid + 1, tr, l, r);
        }
        return get_sum(2 * v, tl, mid, l, mid) + get_sum(2 * v + 1, mid + 1, tr, mid + 1, r);
    }
};

int n, m, a[max_n];
tree t;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int m = inf.readInt();
    for (int i = 0; i < n; ++i) {
        a[i] = inf.readInt();
    }
    t.build(1, 0, n - 1, a);
    int cnt2 = 0;
    while (m--) {
        int tp = inf.readInt();
        if (tp == 1) {
            int l, r, x;
            l = inf.readInt();
            r = inf.readInt();
            x = inf.readInt();
            --l;
            --r;
            t.update(1, 0, n - 1, l, r, x);
        } else {
            ++cnt2;
            int l, r, lo, ro, la, ra;
            l = inf.readInt(1, n);
            r = inf.readInt(l, n);
            lo = ouf.readInt(l, r);
            ro = ouf.readInt(lo + 1, r);
            la = ans.readInt(l, r);
            ra = ans.readInt(la + 1, r);
            --l;
            --r;
            --lo;
            --ro;
            --la;
            --ra;
            int leno = ro - lo + 1, lena = ra - la + 1;
            long long sumo = t.get_sum(1, 0, n - 1, lo, ro);
            long long suma = t.get_sum(1, 0, n - 1, la, ra);
            if (sumo * lena < suma * leno) {
                quitf(_wa, "jury has better answer than participant, qeurry #%d", cnt2);
            } else if (sumo * lena == suma * leno) {
            } else {
                quitf(_fail, "participant has better answer than jury, querry #%d [%d %d] out [%d %d] ans [%d %d]; sumo %I64d, suma %I64d", cnt2, l, r, lo, ro, la, ra, sumo, suma);
            }
        }
    }
    quitf(_ok, "all answers are correct");
}
